<?php
/* Fetches a webpage through proxy

Opens a connection with a proxy and fetches a location.

PARAMETERS:
$sUrl: url of the page to fetch
$sProxyUrl: location of the proxy
$iPort: port where the proxy service listens on
$sPass: username:password

RETURNS:
STRING: output of curl_exec()
*/

function ProxyConnect($sUrl,$sProxyUrl,$iPort="",$sPass=""){
    $ch = curl_init($sUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_PROXY, $sProxyUrl);
    if($iPort!=""){
    	curl_setopt($ch, CURLOPT_PROXYPORT, $iPort);
    }
    if($sPass!=""){
    	// user:password
    	curl_setopt($ch, CURLOPT_PROXYUSERPWD, $sPass);
    }
    return(curl_exec($ch));
}
?>