<?php
/* Setup the default values for the environment variables */
if(!defined('IN_SCRIPT')){
	exit;
}
// context of session
$_CONTEXT = array();
// errors that have occured
$_CONTEXT['errors'] = array();
// silence error output of the THC suite, php errors may take place anyway, errors in the header.php file will always be shown
$_CONTEXT['silent'] = false;
// log errors that have occured
$_CONTEXT['log'] = true;
// did a fatal error take place?
$_CONTEXT['fatal'] = false;
// verbose output on scripts?
$_CONTEXT['verbose'] = true;
// debug scripts?
$_CONTEXT['debug'] = false;
// debug vars
$_CONTEXT['debug_vars'] = array("_PATHS","_CONTEXT","_SERVER","_POST","_GET","_COOKIE","_SESSION");
// current module
$_CONTEXT['module_current'] = "";
// available modules
$_CONTEXT['modules'] = array();
// restricted ip access to the suite?
$_CONTEXT['ip_access'] = false;
// if above is true, set your allowed ip(s) here
$_CONTEXT['ip_allowed'] = array();
// page title
$_CONTEXT['page_title'] = "THC HackSuite CMS";
?>